export declare type SecurityKey = 'error' | 'warning' | 'info' | 'hint';
export interface ISecurities {
    [key: string]: SecurityKey;
}
export interface ILinterConfig {
    command: string;
    rootPatterns: string[] | string;
    isStdout?: boolean;
    isStderr?: boolean;
    debounce?: number;
    args?: Array<string | number>;
    sourceName: string;
    formatLines?: number;
    formatPattern: [string, {
        line: number;
        column: number;
        message: Array<number | string> | number;
        security: number;
    }];
    securities?: ISecurities;
    offsetLine?: number;
    offsetColumn?: number;
}
export interface IConfig {
    linters: {
        [linter: string]: ILinterConfig;
    };
    filetypes: {
        [fileType: string]: string | string[];
    };
}
